(** @author: Benoît Montagu <benoit.montagu@inria.fr>
    Copyright © Inria 2020
*)

module type S = sig
  type t
  val compare: t -> t -> int
  val is_max: t -> bool
  val empty: t
  val extend: t -> Lang.Ast.PP.t -> t
  val pp: Format.formatter -> t -> unit
end

(** Module implementing the "max k cyclic call sites" strategy *)
module CyclicCallSites(Config: sig val max_nesting: int end): S

(** Module implementing the "last k call sites" strategy, as in k-CFA *)
module LastCallSites(Config: sig val max_length: int end): S
